#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define BUF_SIZE 512
char buf[BUF_SIZE];

#define data_blocks  (((1024 * 1024 * 4) - (1024 * 64)) / BUF_SIZE) // 4M - 64K
#define art_blocks   ((1024 * 64) / BUF_SIZE) // 64K
#define zero_blocks  (((1024 * 1024 * 16) / BUF_SIZE) - data_blocks - art_blocks) // 16M - old_data


void copy(FILE *src, FILE *dst, int count)
{
  int i;

  for (i = 0; i < count; i++){
    if(fread(buf, sizeof(buf), 1, src) == 1) {
      fwrite(buf, sizeof(buf), 1, dst);
    } else {
      if(feof(src)){
        printf("Premature end of src file.");
      } else {
        printf("File read error.");
      }
      fclose(src);
      fclose(dst);
      exit(1);
    }
  }
}

int main (int argc, char** argv)
{
  if (argc == 1){
    printf("Usage:\n");
    printf("flash32to128 <input>.bin for generate <input>_128.bin\n");
    printf("flash32to128 <input.bin> <output.bin>\n");
    exit(1);
  }

  FILE *src;
  FILE *dst;
  if ((src=fopen(argv[1], "rb"))==NULL) {
    printf ("Cannot open source file %s.\n", argv[1]);
    exit(1);
  }

  char* dst_path;

  if (argc == 2){
    int len = strlen(argv[1]);
    dst_path = malloc(len + 4 + 1);
    memcpy(dst_path, argv[1], len - 4); // Copy filename without extension
    dst_path[len - 4] = '_';
    dst_path[len - 3] = '1';
    dst_path[len - 2] = '2';
    dst_path[len - 1] = '8';
    memcpy(&(dst_path[len]), &(argv[1][len - 4]), 4); // Copy filename extension
    dst_path[len + 4] = 0;
  } else if (argc >= 3){
      dst_path = argv[2];
  }

  if (dst = fopen(dst_path, "r")) {
      printf("Desternation file already exist.\n");
      fclose(src);
      fclose(dst);
      exit(1);
  }
  if ((dst = fopen(dst_path, "wb")) == NULL) {
      printf("Cannot open desternation file %s.\n", dst_path);
      fclose(src);
      exit(1);
  }


  // Копируем данные флешки за исключением ART раздела
  int i;
  copy(src, dst, data_blocks);
  memset(buf, 0, sizeof(buf));
  for (i = 0; i < zero_blocks; i++){
    fwrite(buf, sizeof(buf), 1, dst);
  }
  copy(src, dst, art_blocks);
  fclose(src);
  fclose(dst);
  if (dst_path == argv[2]) free(dst_path);
  return 0;
}
